<template>
    <div class="page-container">
        <ValidationObserver
            v-if="draft"
            ref="obs"
        >
            <div class="edit__top">
                <div>
                    <div class="campaigns-title">
                        New Campaign
                    </div>
                </div>
                <Buttons
                    :items="btns"
                    custom-class="edit__actions"
                    @deleteCampaign="deleteCampaign"
                    @changeStep="changeStep"
                    @saveDraftTrue="saveDraft(true)"
                    @saveDraftFalse="saveDraft(false)"
                />
            </div>
            <div
                class="row"
            >
                <div class="col-12 col-xl-6 edit__settings">
                    <PushTextEditorCampaign
                        v-if="!secondStep"
                        :text-editor="draft"
                    />
                    <PushScheduledStepCampaign
                        v-else
                        :text-editor="draft"
                    />
                </div>
                <div class="col-12 col-xl-6 edit__preview">
                    <PushCampaignPreview :text-editor="draft" />
                </div>
            </div>
        </ValidationObserver>
    </div>
</template>

<script>
import pushCampaign from '@/mixins/push/campaigns.service'
import PushTextEditorCampaign from "@/components/push/campaigns/PushTextEditorCampaign";
import PushScheduledStepCampaign from "@/components/push/campaigns/PushScheduledStepCampaign";
import PushCampaignPreview from "@/components/push/campaigns/PushCampaignPreview";

export default {
    name: "Edit",
    components: {PushCampaignPreview, PushScheduledStepCampaign, PushTextEditorCampaign},
    mixins: [pushCampaign],
    data() {
        return {
            draft: null,
            secondStep: false,
        }
    },
    computed: {
        btns() {
            const btnNext = {title: 'Next', event: 'changeStep', class: 'blue-btn', icon_after: 'fa-angle-right', key: 'next'} 
            const btnBack = {title: 'Back', event: 'changeStep', class: 'blue-btn', icon: 'fa-angle-left', key: 'prev'}

            const element = !this.secondStep ? btnNext : btnBack
            const launch = this.secondStep ? {title: 'Launch', event: 'saveDraftFalse', class: 'blue-btn', icon_after: 'fa-paper-plane'} : null

                
            const items = [
                {title: 'Cancel', event: 'deleteCampaign', class: 'red-button', icon: 'fa-times'},
                {title: 'Save Drafts', event: 'saveDraftTrue', class: 'light-blue-btn', icon: 'fa-pencil-square-o'},
                element,
                launch
            ]

            return items
        },
    },
    async created() {
        await this.getCampaign()
    },
    methods: {
        async getCampaign() {
            const response = await this.getCampaignsById(this.$route.params.id)
            this.draft = response.data
            this.draft.user_timezone = this.$moment.tz.guess();
        },
        async changeStep() {
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                this.secondStep = !this.secondStep
            } else {
                this.getFormErrors(valid.errors)
            }
        },
        async saveDraft(draft) {
            this.draft.is_draft = draft
            const result = await this.$refs.obs.validate();
            let valid = await this.$refs.obs
            if (result) {
                await this.save(this.$route.params.id, this.draft)
                this.$notify({
                    type: 'success',
                    title: 'Saved'
                });
                if(!draft) this.$router.push('/push/campaigns/')
                setTimeout(() => {
                    this.$refs.obs.reset()
                }, 2000)
            } else this.getFormErrors(valid.errors)

        },
        deleteCampaign() {
            if (this.$route.query.first) {
                this.delete(this.$route.params.id).then(response => {
                    if (response) {
                        this.$emit('getDrafts')
                        this.$emit('getCampaigns')
                        this.$emit('getHistories')
                        this.$router.push('/push/campaigns/')
                    }
                }).catch(error => {
                    console.log(error)
                });
            } else {
                this.$router.push('/push/campaigns/')
            }
        },
    }
}
</script>

<style scoped lang="scss">
.page-container {
    margin-top: 40px;
}

.broadcast-form-header {
   margin-bottom:  15px;
   display: flex;
   flex-wrap: wrap;
   justify-content: space-between;
}

.campaigns-title {
    white-space: nowrap;
    font-size: 28px;
    font-weight: bold;
    margin-bottom: 10px;
}

.light-blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.red-button {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}

.blue-btn {
    @media screen and (max-width: 500px) {
        margin-top: 3px;
    }
}
.button-group {
    margin-left: auto;
    .btn {
        margin-left: 10px;
    }
}

</style>
